-------------------------------------------------------------------------------
--   Projekt   : kniha Cislicove systemy a jazyk VHDL
--   Jm. soub. : komparator.vhd
--   Nazev     : Vypis 8.11
--   Popis     : Komparator pomoci konstrukce when-else a rovnic
-------------------------------------------------------------------------------
--   Datum      Autor             Revize  Poznamka
--   16.8.2006  Martin Poupa      Rev A   Vytvoreno
-------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity komparator is
   port (
      a : in unsigned (3 downto 0);
      b : in unsigned (3 downto 0);
      a_v_b : out std_logic;
      a_vr_b : out std_logic;
      a_r_b : out std_logic;
      a_mr_b : out std_logic;
      a_m_b : out std_logic
   );
end komparator;

architecture a_komp of komparator is
   signal v, r, m : std_logic;
begin
   v <= '1' when a > b else '0';
   r <= '1' when a = b else '0';
   m <= '1' when a < b else '0';
   a_v_b <= v; -- vystup a > b
   a_r_b <= r; -- vystup a = b
   a_m_b <= m; -- vystup a < b
   a_vr_b <= v or r; -- vystup a >= b
   a_mr_b <= m or r; -- vystup a <= b
end a_komp;
