-------------------------------------------------------------------------------
--   Projekt   : kniha Cislicove systemy a jazyk VHDL
--   Jm. soub. : add_sub.vhd
--   Nazev     : Vypis 8.14
--   Popis     : Prepinatelna scitacka/odcitacka
-------------------------------------------------------------------------------
--   Datum      Autor             Revize  Poznamka
--   16.8.2006  Martin Poupa      Rev A   Vytvoreno
-------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity add_sub is
   generic (
      width : positive := 8   -- sirka slova operandu
   );
   port (
      a : in std_logic_vector (width - 1 downto 0);   -- 1. operand
      b : in std_logic_vector (width - 1 downto 0);   -- 2. operand
      pm : in std_logic;   -- prepinac '0' - add / '1' - sub
      s : out std_logic_vector (width - 1 downto 0)   -- vysledek
   );
end add_sub;

architecture prep_add_sub of add_sub is
	signal a_uns, b_uns, s_uns : unsigned (width - 1 downto 0);
begin
	-- typova konverze na unsigned
	a_uns <= unsigned (a);
	b_uns <= unsigned (b);

	-- behavioralni vypocet souctu / rozdilu
	s_uns <= a_uns + b_uns when pm = '0' else a_uns - b_uns;

	-- typova konverze na std_logic
	s <= std_logic_vector (s_uns);
end prep_add_sub;
