-------------------------------------------------------------------------------
--   Projekt   : kniha Cislicove systemy a jazyk VHDL
--   Jm. soub. : dekoder.vhd
--   Nazev     : Vypis 8.2
--   Popis     : Dekoder (binarni kod na kod 1 z N) pomoci procesu a indexace
--               vektoru
-------------------------------------------------------------------------------
--   Datum      Autor             Revize  Poznamka
--   16.8.2006  Martin Poupa      Rev A   Vytvoreno
-------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity dekoder is
   port (
      x : in std_logic_vector (2 downto 0);
      y : out std_logic_vector (7 downto 0)
   );
end dekoder;

architecture a_dekoder of dekoder is
begin
   -- proces se spousti pri zmene signalu x
   process (x)
   begin
      -- naplni vsechny bity vektoru y log. 1
      y <= (others => '1');
      -- podle hodnoty x nastavi prislusny bit vektoru y do log. 0
      y(to_integer(unsigned(x))) <= '0';
   end process;
end a_dekoder;
