-------------------------------------------------------------------------------
--   Projekt   : kniha Cislicove systemy a jazyk VHDL
--   Jm. soub. : reg_n_hr.vhd
--   Nazev     : Vypis 9.1
--   Popis     : Parametrizovatelny hranovy registr s asynchronnim nulovanim
-------------------------------------------------------------------------------
--   Datum      Autor             Revize  Poznamka
--   16.8.2006  Martin Poupa      Rev A   Vytvoreno
-------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

entity reg_n_hr is
   generic (
      n : positive := 8
   );
   port (
      d : in std_logic_vector (1 to n);
      clk, n_r : in std_logic;
      q : out std_logic_vector (1 to n)
   );
end reg_n_hr;

architecture struct of reg_n_hr is
begin
   -- registr s hodinami aktivnimi pri nabezne hrane a asynchronnim nulovanim
   process (clk, n_r)
   begin
      -- realizace asynchronniho nulovani
      if n_r = '0' then
         q <= (others => '0');
      -- realizace synchronniho registru
      elsif clk'event and clk = '1' then
         q <= d;
      end if;
   end process;
end struct;
