-------------------------------------------------------------------------------
--   Projekt   : kniha Cislicove systemy a jazyk VHDL
--   Jm. soub. : reg_n_hl.vhd
--   Nazev     : Vypis 9.2
--   Popis     : Parametrizovatelny hladinovy registr s nulovanim
-------------------------------------------------------------------------------
--   Datum      Autor             Revize  Poznamka
--   16.8.2006  Martin Poupa      Rev A   Vytvoreno
-------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

entity reg_n_hl is
   generic (
      n : positive := 8
   );
   port (
      d : in std_logic_vector (1 to n);
      wr, n_r : in std_logic;
      q : out std_logic_vector (1 to n)
   );
end reg_n_hl;

architecture struct of reg_n_hl is
begin
   -- hladinovy registr s nulovanim
   process (n_r, d, wr)
   begin
      -- realizace asynchronniho nulovani
      if n_r = '0' then
         q <= (others => '0');
      -- realizace hladinoveho registru
      elsif wr = '1' then
         q <= d;
      end if;
   end process;
end struct;
