-------------------------------------------------------------------------------
--   Projekt   : kniha Cislicove systemy a jazyk VHDL
--   Jm. soub. : posuv_reg_bi.vhd
--   Nazev     : Vypis 9.4
--   Popis     : Parametrizovatelny dvojsmerny posuvny registr
-------------------------------------------------------------------------------
--   Datum      Autor             Revize  Poznamka
--   16.8.2006  Martin Poupa      Rev A   Vytvoreno
-------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

entity posuv_reg_bi is
   generic (
      n : positive := 8
   );
   port (
      clk : in std_logic;
      dir : in std_logic;
      sdl : in std_logic;
      sdr : in std_logic;
      q : out std_logic_vector (1 to n)
   );
end posuv_reg_bi;

architecture struct of posuv_reg_bi is
   signal reg : std_logic_vector (1 to n);
begin
   -- realizace dvojsmerneho posuvneho registru
   process (clk)
   begin
      if clk'event and clk = '1' then
         if dir = '1' then
            -- posun registru pravo a nasunuti novych dat zleva
            reg <= sdl & reg (1 to n - 1);
         else
            -- posun registru vlevo a nasunuti novych dat zprava
            reg <= reg (2 to n) & sdr;
         end if;
      end if;
   end process;
   q <= reg;
end struct;
