-------------------------------------------------------------------------------
--   Projekt   : kniha Cislicove systemy a jazyk VHDL
--   Jm. soub. : vratny.vhd
--   Nazev     : Vypis 9.7
--   Popis     : Synchronni reverzibilni citac
-------------------------------------------------------------------------------
--   Datum      Autor             Revize  Poznamka
--   16.8.2006  Martin Poupa      Rev A   Vytvoreno
-------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity vratny is
   generic (
      n : positive := 8
   );
   port (
      reset : in std_logic;
      clk : in std_logic;
      dir : in std_logic;
      q : out std_logic_vector (n - 1 downto 0)
   );
end vratny;

architecture struct of vratny is
begin
   -- vratny citac
   process (reset, clk)
      variable cnt : unsigned (n - 1 downto 0);
   begin
      -- asynchronni reset
      if reset = '1' then
         cnt := (others => '0');
      -- synchronni citac
      elsif clk'event and clk = '1' then
         if dir = '1' then
            cnt := cnt + 1;
         else
            cnt := cnt - 1;
         end if;
      end if;
      -- konverze na typ std_logic_vector
      q <= std_logic_vector (cnt);
   end process;
end struct;

