-------------------------------------------------------------------------------
--   Projekt   : kniha Cislicove systemy a jazyk VHDL
--   Jm. soub. : async_prenos.vhd
--   Nazev     : Vypis 9.9
--   Popis     : Dva ctyrbitove citace v kaskade s asynchronni vazbou
-------------------------------------------------------------------------------
--   Datum      Autor             Revize  Poznamka
--   16.8.2006  Martin Poupa      Rev A   Vytvoreno
-------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity async_prenos is
   port (
      reset : in std_logic;
      clk : in std_logic;
      q : buffer std_logic_vector (7 downto 0)
   );
end async_prenos;

architecture behav of async_prenos is
begin
   -- prvni citac
   process (reset, clk)
      variable cnt : unsigned (3 downto 0);
   begin
      -- asynchronni reset
      if reset = '1' then
         cnt := "0000";
      -- cita na sestupnou hranu clk
      elsif clk'event and clk = '0' then
         cnt := cnt + 1;
      end if;
      -- konverze na typ std_logic_vector
      q(3 downto 0) <= std_logic_vector (cnt);
   end process;

   -- druhy citac
   process (reset, q(3))
      variable cnt : unsigned (3 downto 0);
   begin
      -- asynchronni reset
      if reset = '1' then
         cnt := "0000";
      -- cita na sestupnou hranu q3
      elsif q(3)'event and q(3) = '0' then
         cnt := cnt + 1;
      end if;
      -- konverze na typ std_logic_vector
      q(7 downto 4) <= std_logic_vector (cnt);
   end process;
end behav;
